/* XLink85  -  TI85<->PC  link  program,  Copyright (c) 1996 Jani Halme	*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License or (at */
/* your option) any later version.					*/
/*									*/
/* This program is distributed  in the hope that it will be useful, but */
/* WITHOUT  ANY   WARRANTY;  without  even   the  implied  warranty  of */
/* MERCHANTABILITY  or FITNESS  FOR A  PARTICULAR  PURPOSE. See the GNU */
/* General Public License for more details.				*/
/*									*/
/* You  should  have  received a copy of the GNU General Public License */
/* along  with  this  program;  it  now,  write  to  the  Free Software	*/
/* Foundation, Inc., Mass Ave, Cambridge, MA02139.			*/
/*									*/  
/* The   author   can   be   contacted  by   email   at:  jaadha@utu.fi */

/* Mac modifications: Mark White */
									

#include <MacTypes.h>
#include <Devices.h>
#include <Files.h>
#include <Fonts.h>
#include <Serial.h>
#include <console.h>           
#include <Events.h>             
#include <Types.h>             
#include <Memory.h>
#include <Quickdraw.h>
#include <Fonts.h>
#include <Menus.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <SIOUX.h>    
#include <Timer.h> 
#include <Sound.h>         

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "version.h"


#define TIMAXTIME 100000

unsigned char ID_COMPUTER;


#define PAK_VARHEADER 0x06
#define PAK_DATAPART 0x15
#define PAK_ACKNOWLEDGE 0x56
#define PAK_LASTVAR 0x92
#define PAK_SKIPVAR 0x36
#define PAK_SCREENDUMP 0x64
#define PAK_REQRESEND 0x5a
#define PAK_REQDATA 0x09

FILE *var_file;
unsigned char *buffer;
int calcmode;
short	theOutputRefNum, theInputRefNum;	
SerShk	theSerShkRec;
short	theOutputRefNum2, theInputRefNum2;	
SerShk	theSerShkRec2;
	
unsigned char get_packet(void);
void put_packet(unsigned char packet_type, unsigned short dataword);
unsigned char get85(void);
void put85(unsigned char val);

	
	void SerialDTR1(Boolean value)
	{
	short kAssertDTR, kNegateDTR;
		
	kAssertDTR = 17;  
	kNegateDTR = 18;
		
	Control(theOutputRefNum, value ? kAssertDTR : kNegateDTR, &theSerShkRec);

   }
   
   	void SerialDTR2(Boolean value)
	{
	short kAssertDTR, kNegateDTR;
	
	kAssertDTR = 17;  
	kNegateDTR = 18;
			
	Control(theOutputRefNum2, value ? kAssertDTR : kNegateDTR, &theSerShkRec2);

   }

Boolean SerialCTS1(void) 
{
	SerStaRec myRec;
	
	SerStatus(theInputRefNum,  &myRec);	
	return (myRec.ctsHold == 0);
}
	

Boolean SerialCTS2(void) 
{
	SerStaRec myRec2;
	
	SerStatus(theInputRefNum2,  &myRec2);	
	return (myRec2.ctsHold == 0);
}		

	int ClosePorts()
	{
	
	if(noErr==KillIO(theInputRefNum))		
	if(noErr==KillIO(theOutputRefNum))
	if(noErr==CloseDriver(theInputRefNum))
	CloseDriver(theOutputRefNum);
				
	
	if(noErr==KillIO(theInputRefNum2))		
	if(noErr==KillIO(theOutputRefNum2))
	if(noErr==CloseDriver(theInputRefNum2))
	CloseDriver(theOutputRefNum2);			
				
    }	
	
	int InitPorts()
	{

	theOutputRefNum = 0;
    theInputRefNum = 0;    
    theOutputRefNum2 = 0;
    theInputRefNum2 = 0;
       
	
	if (noErr!=OpenDriver("\p.AOut", &theOutputRefNum))	
		return 1;
		
	if (noErr!=OpenDriver("\p.AIn", &theInputRefNum))
	   return 1; 
	 
	if (noErr!=OpenDriver("\p.BOut", &theOutputRefNum2))	
		return 1;
		
	if (noErr!=OpenDriver("\p.BIn", &theInputRefNum2))
	    return 1;
		
	theSerShkRec.fXOn	= 0;		
	theSerShkRec.fCTS	= 0;		
	theSerShkRec.errs	= 0;		
	theSerShkRec.evts	= 0;		
	theSerShkRec.fInX	= 0;		
	theSerShkRec.fDTR	= 0;		
	
	theSerShkRec2.fXOn	= 0;		
	theSerShkRec2.fCTS	= 0;		
	theSerShkRec2.errs	= 0;		
	theSerShkRec2.evts	= 0;		
	theSerShkRec2.fInX	= 0;		
	theSerShkRec2.fDTR	= 0;	
	
	if (noErr!=Control(theOutputRefNum, 14, &theSerShkRec))	
	return 1;	
	
	if (noErr!=Control(theOutputRefNum2, 14, &theSerShkRec2))		
	return 1;
  
    return 0;
	
	}
	

int writeserial(unsigned char datach)
{ 
  int bits;
  unsigned long titime;  
  UnsignedWide startTime, endTime; 
  unsigned long timedur;

  for (bits=0; bits<8; bits++) 
  {
     
    if (datach & 1) 
    {
    
      SerialDTR1(0);  // drop dtr 
         
      titime = 0;
     
      while (SerialCTS2() == 1)    // wait for cts to drop     
      if(titime++>TIMAXTIME) 
       return -1; 
            
      SerialDTR1(1);   // reset dtr & rts high             
     //  SerialDTR2(1);
     
      titime = 0;
    
      while (SerialCTS2() == 0)     // wait for cts to raise 
      if(titime++>TIMAXTIME) 
      return -1; 
  
    } 
    else 
    {
    
     SerialDTR2(0);   // drop rts
    
     titime = 0;
    
     while (SerialCTS1() == 1)     // wait for dsr to drop 
     if(titime++>TIMAXTIME) 
     return -1; 
        
     //  SerialDTR1(1);     // reset dtr & rts high    
     SerialDTR2(1);  
         
      titime = 0;
      
      while (SerialCTS1() == 0)     // wait for dsr to raise    
      if(titime++>TIMAXTIME) 
      return -1; 
      
    }
    
    datach >>=1;
  }
  
  
     Microseconds(&startTime);

    for (;;)
    {    
    Microseconds(&endTime);   
    timedur = endTime.lo - startTime.lo;
    
    if(timedur >= 10000)
    break;
	}

  return 0;
  
}

int readserial()
{
  int bits;
  unsigned long titime;
  unsigned char datach;
  Boolean ret;  
  UnsignedWide startTime, endTime;
  unsigned long timedur;
 
  datach = 0;

  for (bits=0; bits<8; bits++) 
  { 
 
    titime = 0;
  
    while (ret = SerialCTS1() == 1)  // wait for calculator to start transfer by dropping cts or dsr              
    {
    
    if(titime++>TIMAXTIME) 
    return -1; 
    
     if(SerialCTS2() == 0)
     {
     ret = 1;
     break;
     }        
     }
      
    if(ret == 0)  // dsr has dropped 
     {
    
    datach=(datach>>1)|0x80;
   
    SerialDTR2(0);    // drop rts 

    titime = 0;

    while (SerialCTS1() == 0)     // wait for dsr to be raised by calc 
    if(titime++>TIMAXTIME) 
    return -1; 
  
    //   SerialDTR1(1);    // reset dtr & rts high
    SerialDTR2(1);  
       
    } 
    else      // ctr has dropped 
    {
    
     datach=datach>>1;
  
     SerialDTR1(0);    //  drop dtr
     
     titime = 0;
       
      while (SerialCTS2() == 0)   // wait for cts to be raised by calc
      if(titime++>TIMAXTIME)
      return -1;  
        
      SerialDTR1(1);     // reset dtr & rts high  
      //   SerialDTR2(1);  
    
    }
    
  }
 
  
    Microseconds(&startTime);

    for (;;)
    {    
    Microseconds(&endTime);   
    timedur = endTime.lo - startTime.lo;
    
    if(timedur >= 10000)
    break;
	}
  
  return (int)datach;
  
}

int initserial()
{
  
 SerialDTR1(1);
 SerialDTR2(1);  
          
  return 0;
  
}

void doerror()
{
				
 if(var_file != NULL)
	fclose(var_file);
	
 if(buffer != NULL)
   free(buffer);
				
	ClosePorts();

printf("Transfer Error.\n");
					
	exit(0);

}


void put_packet(unsigned char packet_type, unsigned short dataword)
{
  unsigned short checksum, i;
  unsigned char dummy;
  
  put85(ID_COMPUTER);  
  put85(packet_type);  
  put85(dataword & 0xFF);  
  put85((dataword >> 8) & 0xFF);
  
  if (dataword!=0)
    {
      checksum=0;
      
    for(i=0;i<dataword;i++)
	{
	  put85(buffer[i]);	  
	  checksum+=buffer[i];
	}
	
      checksum=checksum & 0xFFFF;      
      put85(checksum & 0xFF);     
      put85((checksum >> 8) & 0xFF);     
      dummy = get_packet();
      
      if(dummy != 0x56)
      doerror();
		
    }
} 


unsigned char get_packet(void)
{
  unsigned char dummy;
  unsigned char command;
  
  dummy=get85();
  command=get85();
  if(command == 0x36)
  doerror();
  dummy=get85();
  dummy=get85();
  
  return command;
  
}		

void put85(unsigned char val)
{

if(writeserial(val) == -1)
{
 printf("Write Timeout Error.\n");
 doerror();
}

}


unsigned char get85(void)
{
  unsigned char val;
  int ret;
  int retry;
  int timeout;
    
    retry=0; 
    timeout = 0;
    val=0;

    
      while((ret=readserial())==-1) 
      {     
      if(retry > 5)
      {     
      timeout = 1;   
      break;	
	  }
		
      retry++;
      
      }
      
      if(timeout == 1)
      {      
      printf("Read Timeout Error.\n");     
      doerror();     
      }
    
     val = ret;
 
     return val;
     
     
}
			
int init_comm ()
{
  unsigned long ticks;  
      
  printf("Mac TI82-6 Serial Link.\n");
  
       
    if(InitPorts() == 1)
    return 1;
    
    initserial();
 
    Delay(100, &ticks);   
    
    printf("Ready to transfer files.\n");
    printf("Hit any key to begin transfer.\n");
             
    getch();   
}

/* initializes link and checks permissions on /dev/port */

int init_link()
{

  buffer=NULL;

  buffer=(unsigned char*)malloc(32768 * 2 * sizeof(unsigned char));
  
  if (buffer==NULL)
    return 1;
        
    return 0;
}

int sendgroup(char filename[255])
{
	
	unsigned short checkbytes, var_length, i, varcnt, hdr_len;
	unsigned char var_type;
	unsigned char var_namelength;
	unsigned char var_name[9];
	unsigned long var_offset;
	unsigned short dummy;
	int ret;
   
	varcnt=0;
	
	if(fseek(var_file, 0x35, 0) != 0)
	doerror();

	checkbytes  = fgetc(var_file);
    checkbytes += (fgetc(var_file)<<8);
       
	var_offset=0x37; 	
		
            do
			{
			
				if(fseek(var_file, var_offset+4, SEEK_SET) != 0)
					doerror();
				 
	 			if((ret=fread(&var_type, sizeof(char), 1, var_file)) != 1)
	 			doerror();
	 			
	 			if((calcmode == 85) || (calcmode == 86))
	 			if((ret=fread(&var_namelength, sizeof(char), 1, var_file)) != 1)
	 			doerror();		
	 			
	 			memset(var_name, 0, sizeof (var_name));
	 			 
	 			if((calcmode == 82) || (calcmode == 83) || (calcmode == 832))
	 			var_namelength = 8;	 
	 			 
	 		    if( var_namelength > 8)
                doerror();
	 			 			
	 			if((ret=fread(&var_name, sizeof(char), var_namelength, var_file)) != var_namelength)
	 			doerror(); 
					
				var_name[var_namelength]=0;				
					
				if(calcmode == 832)
				{	
				if((ret=fread(&dummy, sizeof(char), 1, var_file)) != 1)	
				doerror();	
				if((ret=fread(&dummy, sizeof(char), 1, var_file)) != 1)	
				doerror();		 			 
				}
										
		      var_length  = fgetc(var_file);	          
              var_length += (fgetc(var_file)<<8);
              
                if(var_length == 0)
                {
                return 1;
                }
  		
				buffer[0]=(var_length & 0xFF);							
				buffer[1]=(var_length >> 8) & 0xFF; 	
				buffer[2]=var_type; 			
				buffer[3]=0;
				
				memcpy(buffer+4, &var_name, var_namelength);		
								
				put_packet(PAK_VARHEADER, var_namelength+4);
					
				i = get_packet();	
						
				if(i != PAK_REQDATA)
				doerror();
							
				put_packet(PAK_ACKNOWLEDGE, 0);
						
		        if((ret=fread(buffer, sizeof(char), var_length, var_file)) != var_length)
		        doerror();
					
				put_packet(PAK_DATAPART, var_length);
					
				varcnt++;
				
				if((var_offset=ftell(var_file)) == -1)
					doerror();
					
				printf("Number of files transferred = %d\n", varcnt); 	
				
			} while (var_offset<(0x37+checkbytes));

					
	            return varcnt;
}


void main(int argc, char** argv)
{
	int argc2;
	int ret;
	unsigned char filename[255];
	unsigned char *exten;
	unsigned char ext[4];
	unsigned short i;
	
	  	SIOUXSettings.asktosaveonclose = false;		
  //	SIOUXSettings.autocloseonquit = true;	

	
	argc2 = 0;
	
    argc2 = ccommand(&argv);

	printf(VERSION_HDR);
	
	if ((argc2 <= 1) || (argc2 >= 3))
    {
      printf ("usage: %s tifile.8xx\n", argv[0]);
      exit (0);    
    }
       
     memset(filename, 0, sizeof (filename));
     
     strncpy (filename, argv[1], 255);
     
     printf("%s\n", filename);
     
     exten = NULL;
      
     exten = strrchr(filename,'.');
       	
    if(exten == NULL)
	{
	printf("Input filename is missing TI extension.\n");	
	printf("Try enclosing filename with quotes if it contains spaces.\n");
	exit (0);	
	}
	
	exten++;

	ext[0] = *exten++;
	ext[1] = *exten++;
	ext[2] = *exten++;

	calcmode = 0;

	if((ext[0] == '8') && (ext[1] == '2'))
	{
	calcmode = 82;	
	ID_COMPUTER = 0x02;  
	}
	else if((ext[0] == '8') && (ext[1] == '3'))
	{	
    calcmode = 83;	
	ID_COMPUTER = 0x03;    
	}
	else if((ext[0] == '8') && (ext[1] == 'x'))
	{	
	calcmode = 832;	
	ID_COMPUTER = 0x23;     
	}	
	else if((ext[0] == '8') && (ext[1] == 'X'))
	{	
	calcmode = 832;	
	ID_COMPUTER = 0x23; 
	}	
	else if((ext[0] == '8') && (ext[1] == '5'))
	{	
	calcmode = 85;	
	ID_COMPUTER = 0x05;   
	}	
	else if((ext[0] == '8') && (ext[1] == '6'))
	{	
	calcmode = 86;	
	ID_COMPUTER = 0x06;		
	}
    else
    {
    printf("Input filename has wrong extension.\n");
    printf("Try enclosing filename with quotes if it contains spaces.\n");
	exit (0);
    }
    
    var_file=NULL;
     
    var_file=fopen(filename, "rb");
	
	if(var_file == NULL)
	{
	printf("File open Error.\n");
	exit(0);
	}
	
	if((ret=fread(buffer, sizeof(char), 8, var_file)) != 8)
	{
	if(var_file != NULL)
	fclose(var_file);
	printf("File Read Error.\n");
	exit(0);
	}
	
	if(memcmp(buffer, "**TI", 4) != 0)
	{
	if(var_file != NULL)
	fclose(var_file);
	printf("File ID Error.\n");
	exit(0);
	}
			
 if(init_comm () == 1)
  {
  if(var_file != NULL)
  fclose(var_file);
  ClosePorts();
  printf("Init serial ports error. Make sure Appletalk is off.\n");
  exit (0);
  }
 
 	
  if(init_link() == 1)
  {
  if(var_file != NULL)
  fclose(var_file);
  ClosePorts();
  printf("Init Memory Error.\n");
  exit (0);
  }	
	
  ret = sendgroup(filename);	
  if(ret == -1)
  doerror();
		
  put_packet(PAK_LASTVAR, 0);
  
  i = get_packet();
      
  if(i != 0x56)
    doerror();
    
    					
   if(buffer != NULL)
    free(buffer);
										
	if(var_file != NULL)
	 fclose(var_file);
		
     ClosePorts();
   
    printf ("Files transferred.\n");
		
	
}
