
/*  Sashi89 - TI89-Amiga communication program
 *  Copyright (C) 2000, 2001  Olivier Croquette (ocroquette@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 /* Mac modifications: Mark White */

#include <MacTypes.h>
#include <Devices.h>
#include <Files.h>
#include <Fonts.h>
#include <Serial.h>
#include <console.h>           
#include <Events.h>             
#include <Types.h>             
#include <Memory.h>
#include <Quickdraw.h>
#include <Fonts.h>
#include <Menus.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <Timer.h>
#include <SIOUX.h>     
#include <Sound.h> 
#include <stdio.h>              
#include <stdlib.h>
#include <string.h> 
               

#define TIMAXTIME 100000
#define MAX_NAMELENGTH  8

unsigned char TIID;

FILE *fptr;
unsigned char *buffer;

short	theOutputRefNum, theInputRefNum;	
SerShk	theSerShkRec;
short	theOutputRefNum2, theInputRefNum2;	
SerShk	theSerShkRec2;
	

#define tipkt(a, y, z, x) { \
     a.device = (TIID & 0x0f); \
     a.command = y; \
     a.length = z; \
     a.length2 = x; \
}

typedef struct TIPacket
{
  unsigned char device;
  unsigned char command;
  unsigned char length;
  unsigned char length2;
  
}
TIPacket;

typedef struct TIVarhead
{
  unsigned char length;
  unsigned char length2;
  unsigned char empty1;
  unsigned char empty2;
  unsigned char type;
  unsigned char namelen;
}
TIVarhead;

typedef struct TIVarempty
{
  unsigned char empty[4];
  unsigned char size[2];
}
TIVarempty;


	void SerialDTR1(Boolean value)
	{
	short kAssertDTR, kNegateDTR;
	
	kAssertDTR = 17;  
	kNegateDTR = 18;
		
	Control(theOutputRefNum, value ? kAssertDTR : kNegateDTR, &theSerShkRec);
   }
   
   	void SerialDTR2(Boolean value)
	{
	short kAssertDTR, kNegateDTR;
	
	kAssertDTR = 17;  
	kNegateDTR = 18;
		
	Control(theOutputRefNum2, value ? kAssertDTR : kNegateDTR, &theSerShkRec2);
   }

Boolean SerialCTS1(void) 
{
	SerStaRec myRec;
	
	SerStatus(theInputRefNum,  &myRec);
	
	return (myRec.ctsHold == 0);
}
	
Boolean SerialCTS2(void) 
{
	SerStaRec myRec2;
	
	SerStatus(theInputRefNum2,  &myRec2);
	
	return (myRec2.ctsHold == 0);
}
		
	int ClosePorts()
	{
	
	if(noErr==KillIO(theInputRefNum))		
    if(noErr==KillIO(theOutputRefNum))
	if(noErr==CloseDriver(theInputRefNum))
	CloseDriver(theOutputRefNum);
				
	
	if(noErr==KillIO(theInputRefNum2))	
	if(noErr==KillIO(theOutputRefNum2))
	if(noErr==CloseDriver(theInputRefNum2))
    CloseDriver(theOutputRefNum2);			
				
}	

	int InitPorts()
	{

	theOutputRefNum = 0;
    theInputRefNum = 0;    
    theOutputRefNum2 = 0;
    theInputRefNum2 = 0;
    	
	if (noErr!=OpenDriver("\p.AOut", &theOutputRefNum))	
		return 1;
		
	if (noErr!=OpenDriver("\p.AIn", &theInputRefNum))	
	   return 1;	 
	 
	if (noErr!=OpenDriver("\p.BOut", &theOutputRefNum2))	
		return 1;
		
	if (noErr!=OpenDriver("\p.BIn", &theInputRefNum2))
	    return 1;
		
	theSerShkRec.fXOn	= 0;		
	theSerShkRec.fCTS	= 0;		
	theSerShkRec.errs	= 0;		
	theSerShkRec.evts	= 0;		
	theSerShkRec.fInX	= 0;		
	theSerShkRec.fDTR	= 0;	
	
	theSerShkRec2.fXOn	= 0;	
	theSerShkRec2.fCTS	= 0;		
	theSerShkRec2.errs	= 0;		
	theSerShkRec2.evts	= 0;	
	theSerShkRec2.fInX	= 0;		
	theSerShkRec2.fDTR	= 0;		
	
	if (noErr!=Control(theOutputRefNum, 14, &theSerShkRec))	
	return 1;
	
	if (noErr!=Control(theOutputRefNum2, 14, &theSerShkRec2))	
	return 1;

    return 0;
	
	}	

int writeserial(unsigned char *dataptr)
{
   unsigned char datach;
   int bits;
   unsigned long titime;
   UnsignedWide startTime, endTime;  
   unsigned long timedur;
  
  datach = *dataptr;
  	
  for (bits=0; bits<8; bits++) 
  {  
    if (datach & 1) 
    {
    
    SerialDTR1(0);  // drop dtr 
      
    titime = 0;
     
      while (SerialCTS2() == 1)    // wait for cts to drop      
      if(titime++>TIMAXTIME) 
       return -1;
     
      SerialDTR1(1);   // reset dtr & rts high            
    // SerialDTR2(1);  
     
      titime = 0;
    
    while (SerialCTS2() == 0)     // wait for cts to raise  
    if(titime++>TIMAXTIME) 
    return -1;
    
    } 
    else 
    {
  
    SerialDTR2(0);   // drop rts
      
     titime = 0;
    
     while (SerialCTS1() == 1)     // wait for dsr to drop
     if(titime++>TIMAXTIME) 
     return -1;
       
   //   SerialDTR1(1);     // reset dtr & rts high    
        SerialDTR2(1);  
         
       titime = 0;
      
       while (SerialCTS1() == 0)     // wait for dsr to raise    
       if(titime++>TIMAXTIME) 
       return -1;      
       
    }
    
    datach >>=1;
  }
 
  
    Microseconds(&startTime);

    for (;;)
    {    
    Microseconds(&endTime);   
    timedur = endTime.lo - startTime.lo;
    
    if(timedur >= 10000)
    break;
	}
	  

  return 0;
  
}



int readserial()
{
  int bits;
  unsigned long titime;
  unsigned char datach;
  Boolean ret; 
  UnsignedWide startTime, endTime; 
  unsigned long timedur;
  
  datach = 0;
 
  for (bits=0; bits<8; bits++) 
  { 
  
 titime = 0;
  
  while (ret = SerialCTS1() == 1)  // wait for calculator to start transfer by dropping cts or dsr            
  {
  
  if(titime++>TIMAXTIME) 
  return -1; 
    
     if(SerialCTS2() == 0)
     {
     ret = 1;
     break;
     }        
     }
      
  if(ret == 0)  // dsr has dropped 
    {
    
    datach=(datach>>1)|0x80;
   
    SerialDTR2(0);    // drop rts 
    
  titime = 0;

  while (SerialCTS1() == 0)     // wait for dsr to be raised by calc 
  if(titime++>TIMAXTIME) 
  return -1;
  
   //   SerialDTR1(1);    // reset dtr & rts high
        SerialDTR2(1);  
       
    } 
    else      // ctr has dropped 
    {
    
     datach=datach>>1;
  
    SerialDTR1(0);    //  drop dtr
     
       titime = 0;
       
       while (SerialCTS2() == 0)   // wait for cts to be raised by calc
       if(titime++>TIMAXTIME)
        return -1;  
       
       SerialDTR1(1);     // reset dtr & rts high    
    //   SerialDTR2(1);  
     
    }
    
  }
 
  
    Microseconds(&startTime);

    for (;;)
    {    
    Microseconds(&endTime);   
    timedur = endTime.lo - startTime.lo;
    
    if(timedur >= 10000)
    break;
	}
	 
  
  return (int)datach;
  
}

int initserial()
{
  
 SerialDTR1(1);
 SerialDTR2(1);  
          
  return 0;
  
}

void doerror()
{

    if(fptr != NULL)
    fclose(fptr);
    
    if(buffer != NULL)
    free (buffer);
    
    ClosePorts();
    
    printf("Transfer Error.\n");
    
    exit(0);

}


void tiwrite(unsigned char *buf, int size)
{

 int n;
 int timeout;

  timeout = 0;

   for(n=0;n<size;n++) 
    {
   
     if(writeserial(&buf[n])==-1) 
     {
     timeout = 1;
	 break;
      }
      
    }
       
   if(timeout == 1)
   {
    printf ("Write Timeout.\n");
    doerror();    
   }

return;

}



void tiread(unsigned char *buf, int size)
{
int n,retry,ret;
int timeout;
 

   retry = 0;
   timeout = 0;
   
    for(n=0;n<size;n++) 
    {
      while((ret=readserial())==-1) 
      {
      
      if(retry > 5)
      {      
      timeout = 1;   
      break;	
	 }

      retry++;
      
      }    
      
      if(timeout == 1)
        break;
        
     buf[n] = ret;
     
      }
      
    if(timeout == 1)
    {
    printf ("Read Timeout.\n");
    doerror(); 
    }
        
     return;
}

unsigned short calc_sum(unsigned char *datacs, int len)
{
  unsigned char *val = datacs;
  int i;
  int ret = 0;

  for (i = 0; i < len; i++)
    ret += val[i];

  ret &= 0xFFFF;

  return (unsigned short) ret;
}

void sendpack(TIPacket *pack)
{

 tiwrite (pack, sizeof (TIPacket));
 
  return;
}

unsigned char getpack(TIPacket *pack)
{
unsigned char command;

tiread (pack, sizeof (TIPacket));
   
  command = pack->command;
  
  if(command == 0x36)
  doerror();
 
  return command;
}

int init_comm ()
{

 unsigned long ticks;  
    
  printf("mac TI89-92 serial link.\n");
         
    if(InitPorts() == 1)
    return 1;
    
    initserial();

    Delay(100, &ticks);   
    
    printf("Ready to transfer files.\n");
    printf("Hit any key to begin transfer.\n");
             
    getch();
   
   return 0;
 
}



int sendvardata(FILE *fptr, unsigned char *folder, unsigned char *name, unsigned char type)
{
  unsigned short size;
  unsigned char fullname[200];
  
  unsigned long ticks;
  unsigned short chksum;
  unsigned char chksum1;
  unsigned char chksum2;

  TIVarhead head;
  TIVarempty empty;
  
  TIPacket packet;
  unsigned short sendlen;
  
  unsigned short size1;
  unsigned short size2;
  unsigned short dummy;
  int ret;
    
  fgetc(fptr);
  fgetc(fptr);
  fgetc(fptr);
  fgetc(fptr);

  size1 = fgetc(fptr);
  size1 = (size1 << 8) & 0xFF00;
  
  size2 = fgetc(fptr);
  size2 = size2 & 0x00FF;
  
  size = size1 | size2;

  if(size == 0)
  {
    return 1;
  }
  
  buffer = NULL;

  buffer = calloc(size,sizeof(unsigned char));
  
  if(buffer == NULL)
  {
  return 1;
  }
  
  if((ret=fread(buffer, sizeof(unsigned char),size,fptr)) != size)
  return 1;	
    
      memset(fullname, 0, sizeof (fullname));
      memset(&head, 0, sizeof(TIVarhead));
      memset (&empty, 0, sizeof (TIVarempty));
       
      head.length = (size+2) & 0xFF;
      head.length2 = ((size+2) >> 8) & 0xFF;
      head.empty1 = 0;
      head.empty2 = 0;
      head.type = type;
      head.namelen = sprintf (fullname, "%s\\%s", folder, name);
           
      printf("%s\n", fullname);

      chksum = calc_sum(&head, sizeof (TIVarhead)) + calc_sum (fullname, head.namelen);
	
	  chksum1 = chksum & 0xFF;
	   
	  chksum2 = (chksum>>8) & 0xFF;
 
      sendlen = sizeof (TIVarhead) + head.namelen + 1;
      
      tipkt(packet, 0xc9, sendlen & 0xFF, (sendlen>>8) & 0xFF);  

      sendpack(&packet);
            
      tiwrite(&head, sizeof (TIVarhead));    
  
      tiwrite(fullname, head.namelen + 1);
          
      tiwrite(&chksum1, 1);
          
      tiwrite(&chksum2, 1);
      
      dummy = getpack(&packet);
      
      if(dummy != 0x56)
      doerror();
     
      dummy = getpack(&packet);
      
      if(dummy != 0x09)
      doerror();

      sendlen = size + sizeof (TIVarempty);
      
      empty.size[0] = (size>>8) & 0xFF;
      empty.size[1] =  size & 0xFF;
       
      chksum = calc_sum(&empty, sizeof (TIVarempty)) + calc_sum (buffer, size);
      
      chksum1 = chksum & 0xFF;
        
      chksum2 = (chksum>>8) & 0xFF;

      tipkt(packet, 0x56, 0, 0);
      
      sendpack(&packet);
  
      tipkt(packet, 0x15, sendlen & 0xFF, (sendlen>>8) & 0xFF); 
 
      sendpack(&packet);

      tiwrite(&empty, sizeof(TIVarempty));
      
      tiwrite(buffer, size);
        
      tiwrite(&chksum1, 1);   
      
      tiwrite(&chksum2, 1);
      
      dummy = getpack(&packet);
      
      if(dummy != 0x56)
      doerror();
      
      tipkt(packet, 0x92, 0, 0);
           
      sendpack(&packet);
      
      dummy = getpack(&packet);
      
      if(dummy != 0x56)
      doerror();

      if(buffer != NULL)
      free (buffer);
      
      buffer = NULL;

      return 0;

}


int dogroup(char *filename)
{
  unsigned char folder[MAX_NAMELENGTH+1];
  int nb_entries;
  unsigned char header[9];
  int entry;
  unsigned long offset;
  unsigned char name[MAX_NAMELENGTH+1];
  unsigned char type;
  unsigned char comment[41];
  long backup_offset;
  int ret;
  unsigned short dummy;
 
 
  fgetc(fptr); 
  fgetc(fptr); 
   
   memset(folder, 0, sizeof (folder));
  
  if(fread(folder,1,MAX_NAMELENGTH,fptr) != MAX_NAMELENGTH)
       return(1);

   folder[MAX_NAMELENGTH] = 0;
  
    if (fread(comment,1,sizeof(comment)-1,fptr) != sizeof(comment)-1)
    return(1);
    
    nb_entries  = fgetc(fptr);
    nb_entries += (fgetc(fptr)<<8);


    for (entry=1; entry <= nb_entries ; entry++)
    {    
      offset = fgetc(fptr);
      offset += fgetc(fptr)<<8;
      offset += fgetc(fptr)<<16;
      offset += fgetc(fptr)<<24;
                       
      memset(name, 0, sizeof (name));

      if ( (ret=fread(name,1,MAX_NAMELENGTH,fptr)) != MAX_NAMELENGTH )
      return 1;
    
      name[MAX_NAMELENGTH] = 0;
      
      type = fgetc(fptr);     
      fgetc(fptr);

      fgetc(fptr); 
      fgetc(fptr);
     
      if (type != 0x1F)
      {  
      
      if((backup_offset=ftell(fptr)) == -1) 
           return 1; 
				
        if (fseek(fptr,offset, SEEK_SET) != 0)
        return 1;
   
        if ( (ret=sendvardata(fptr,folder,name, type)) )
	      return 1;
       
        if (fseek(fptr,backup_offset, SEEK_SET) != 0)
        return 1;
     
      }
      else 
      {     
        strncpy(folder,name,MAX_NAMELENGTH);
        
        folder[MAX_NAMELENGTH] = 0;
        
      }

    }
  
   
  return 0;
  
}




main (int argc, char **argv)
{
  unsigned char filename[255];
  int argc2;
  unsigned long ticks;
  int ret;
  unsigned char *exten;
  unsigned char ext[4];
   
  	SIOUXSettings.asktosaveonclose = false;		
  //	SIOUXSettings.autocloseonquit = true;	
  	
  	fptr = NULL;
  	buffer = NULL;
  	
   argc2 = 0;
	
   argc2 = ccommand(&argv);

   if ((argc2 <= 1) || (argc2 >= 3))
    {
      printf ("usage: %s tifile.xxx\n", argv[0]);
      exit (0);
    }

     memset(filename, 0, sizeof (filename));

     strncpy (filename, argv[1], 255);
     
     printf("%s\n", filename);
     
    exten = NULL;
     
    exten = strrchr(filename,'.');
       	
    if(exten == NULL)
	{
	printf("Input filename is missing TI extension.\n");
	printf("Try enclosing filename with quotes if it contains spaces.\n");	
	exit (0);	
	}
	
	exten++;

	ext[0] = *exten++;
	ext[1] = *exten++;
	ext[2] = *exten++;

	
	if((ext[0] == '8') && (ext[1] == '9'))
	{
	TIID = 0x98;
	}
	else if((ext[0] == '9') && (ext[1] == '2'))
	{	
	TIID = 0x89;  
	}	
	else if((ext[0] == '9') && (ext[1] == 'X'))
	{	
	TIID = 0x89;  
	}
	else if((ext[0] == '9') && (ext[1] == 'x'))
	{	
	TIID = 0x89;  
	}
    else
    {
    printf("Input filename has wrong extension.\n");
    printf("Try enclosing filename with quotes if it contains spaces.\n");
	exit (0);
    }

    fptr=fopen(filename, "rb");
	
	if(fptr == NULL)
	{
	printf("File open Error.\n");
	exit(0);
	}
	
	if((ret=fread(filename, sizeof(char), 8, fptr)) != 8)
	{
	if(fptr != NULL)
	fclose(fptr);
	printf("File Read Error.\n");
	exit(0);
	}
	
	if(memcmp(filename, "**TI", 4) != 0)
	{
	if(fptr != NULL)
	fclose(fptr);
	printf("File ID Error.\n");
	exit(0);
	}
	
 if(init_comm () == 1)
  {
  if(fptr != NULL)
  fclose(fptr);
  ClosePorts();
  printf("Init serial ports error. Make sure Appletalk is off.\n");
  exit (0);
  }

     ret = dogroup(filename);

    if(ret == 1)
    {
    doerror();
    }
    else
    {
     
    if(fptr != NULL)
    fclose(fptr);
    
    if(buffer != NULL)
    free (buffer);
         
     ClosePorts();
     
     printf ("Files transferred.\n");
     
     }  
     
  }

