/*  Sashi89 - TI89-Amiga communication program
 *  Copyright (C) 2000, 2001  Olivier Croquette (ocroquette@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#define BITS_PER_BYTE 8

#define BYTE_ERROR 1

#define HARD_TIMEOUT 1


typedef unsigned char ti_byte;


/* Open the port, this is the first thing to do.
	 Return !=0 if problem */
int    ti_openport(void );


/* Close the port, this is the last thing to do.
	 Return !=0 if problem */
void   ti_closeport(void );


/* Send a single bit
	 Return !=0 if problem */
inline int    ti_sendbit(ti_byte bit);

/* Recv a single bit
	 Return !=0 if problem */
inline int    ti_recvbit(ti_byte *result);

/* Recv a byte
	 Return !=0 if problem */
int ti_recvbyte(unsigned char *result );
/* Send a byte
	 Return !=0 if problem */
int ti_sendbyte(ti_byte byte);

/* Send 'nb' bytes
	 Return !=0 if problem */
int ti_sendbytes(ti_byte *bytes,int nb);

/* Tell if parallel or serial version has been compiled : */
char *ti_version(void );


/* Init the parallel or serial port, depending
	 of which symbol is defined in hard.c
	 That means that lines will be set to normal state,
	 so that the TI don't think a comm is in progress
*/
inline void  	ti_initport(void );


